SystemOrganization addCategory: #'Mercury-Prototype-RunTimeDebuggingSupport'!

Object subclass: #RunTimeDebuggingSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-RunTimeDebuggingSupport'!

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:35'!
addInstVarNamed: anIvName inClass: baseObject

	baseObject addInstVarNamed: anIvName ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 2/19/2013 13:56'!
addMethod: aString inClass: aClass

	^ aClass compile: aString "returns a symbol"

! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 16:21'!
changeClassTo: aClassNameAsString of: anObject
	
	self vm_changeClassTo: (Smalltalk globals at: aClassNameAsString asSymbol) of: anObject ! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/9/2013 12:05'!
classNamed: aClassNameAsString inPackage: baseObject

	^ (baseObject classes select: [:class | class name = aClassNameAsString]) first! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 2/19/2013 10:48'!
classNamesInPackage: baseObject

	^ (baseObject classes collect: [:class | class name])! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:19'!
classOfMethod: aMethod

	^ aMethod methodClass! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:29'!
contextAt: aContextIndex forProcess: aProcess
	
	[aProcess handler = nil] whileTrue: []. "active waiting on handler installation"
	aProcess handler goToStackIndex: aContextIndex.
	^ aProcess handler currentContext.! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 9/2/2013 12:17'!
contextForProcess: aProcess

	^ aProcess handler currentContext .

	! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 14:34'!
currentContextIndexForProcess: aProcess
	
	[aProcess handler = nil] whileTrue: []. "active waiting on handler installation"
	^ aProcess handler getStackIndex.! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 8/25/2013 12:56'!
debug: aSelector forTestClass: aTestClass
	
	[(aTestClass selector: aSelector) debug] fork.
! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 16:40'!
definitionOfClass: aClass

	"can be done via the rt deb support primitives"

	^ aClass definition ! !

!RunTimeDebuggingSupport class methodsFor: 'exception' stamp: 'NickPapoulias 1/29/2013 20:14'!
descriptionForException: anException

	^ anException description ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 4/24/2013 13:13'!
dictionaryForContext: aContext

	|dict names namesValuesAssocs|

	names := aContext debuggerMap tempNamesForContext: aContext.
	namesValuesAssocs := OrderedCollection new.
	names doWithIndex: [:item :index |
		namesValuesAssocs add: item -> (aContext debuggerMap namedTempAt: index in: aContext) printString.
	].
	dict := Dictionary newFrom: namesValuesAssocs. 
	dict at: 'thisContext' put: aContext printString.
	
	^ dict.
! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 4/24/2013 13:13'!
dictionaryForReceiverInContext: aContext

	|receiver dict|
	receiver := aContext receiver.
	dict := Dictionary newFrom: 
		(receiver class allInstVarNames collect: [ :each |
		each -> (receiver instVarNamed: each) printString
	]).

	dict at: 'self' put: receiver printString.
	
	^ dict.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 9/2/2013 16:22'!
disableMetaBehaviorForRegistered 

	Interpreter disableMetaBehaviorForRegistered ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 9/2/2013 16:22'!
enableMetaBehaviorForRegistered 

	Interpreter enableMetaBehaviorForRegistered ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:24'!
environmentAddress 

	^ SeamlessDeamonManager default address! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 8/1/2013 16:18'!
evaluate: aString

	|exception responce|

	[[
		Interpreter enableMetaBehaviorForRegistered.
		responce := Compiler evaluate: aString.
	] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[(responce = nil) & (exception = nil)] whileTrue: [ Processor yield ]. "active waiting on computation"

	^ responce ifNil: [exception]
! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 9/2/2013 12:20'!
evaluate: expression in: context

	|exception responce|

	[[
		Interpreter enableMetaBehaviorForRegistered.
		responce := Compiler new evaluate: expression in: context to: context receiver .
	] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[(responce = nil) & (exception = nil)] whileTrue: [ Processor yield ]. "active waiting on computation"

	^ responce ifNil: [exception]
! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:25'!
globalAt: aName

	^ Smalltalk globals at: aName asSymbol! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:31'!
globalAt: aName put: anObject

	^ Smalltalk globals at: aName asSymbol put: anObject! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:20'!
globalNames 

	^ Smalltalk globals keys! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 11:23'!
globalsDictionary

	^ Smalltalk globals! !

!RunTimeDebuggingSupport class methodsFor: 'exception' stamp: 'NickPapoulias 1/10/2013 13:16'!
handlerProcessForException: anException

	^ anException handlerProcess ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/9/2013 15:57'!
inContext: baseObject forTempNamed: aTempName put: anObject

	baseObject tempNamed: aTempName put: anObject! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:53'!
interruptedProcesses

	^ DebuggingSeed interruptedProcesses! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/11/2013 18:57'!
intoForProcess: aProcess 

	aProcess handler into

	! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 4/11/2013 16:55'!
isMetaForClass: aClass

	^ aClass class = Metaclass! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 15:05'!
ivsForClass: aClass

	^ self vm_instVarOf: aClass at: 4.! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 4/9/2013 14:32'!
kernelClasses

	^ {'Object'  . 'ClassDescription'  . 'ContextPart'  . 'SystemDictionary'  . 'Exception'  . 'CompiledMethod'  . 'PackageInfo'  . 'Process' } 
	! !

!RunTimeDebuggingSupport class methodsFor: 'misc' stamp: 'NickPapoulias 12/24/2012 17:04'!
metaLevelUpdate: aSystemAnnouncement! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/29/2013 18:51'!
methodForContext: aContext 

	^ aContext method! !

!RunTimeDebuggingSupport class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 12:07'!
methodOf: aClass at: aMethodName 
	
	^ aClass methodDict at: aMethodName ! !

!RunTimeDebuggingSupport class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:52'!
methodsOf: aClass inProtocol: aProtocolName 
	
	|methodNames|
	
	methodNames := OrderedCollection new.
	
	aClass methodDict do: [:method |
		
		method protocol = aProtocolName ifTrue: [methodNames add: method selector]
			
	].

	^ methodNames ! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 19:10'!
nameForProcess: aProcess 

	^ aProcess name

	

	! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/29/2013 20:12'!
nameOfPackage: aPackage 

	^ aPackage packageName! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/11/2013 12:07'!
newClassNamed: aNewClassName inPackage: aPackage

	^ Object subclass: aNewClassName asSymbol  
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aPackage externalName. ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/9/2013 12:08'!
newInstanceForClass: aClass

	"can be done through vm primitive"

	^ aClass new! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/11/2013 11:00'!
newPackageNamed: aPackageName

	^ PackageOrganizer default packageNamed: aPackageName ifAbsent: [(PackageInfo new packageName: aPackageName) register]! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 16:24'!
objectHalt: anObject

	anObject halt! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:49'!
onArgumentFor: anObject do: aBlock

	Interpreter on: AsArgument for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:49'!
onInteractionFor: anObject with: anotherObject do: aBlock


	Interpreter on: (ObjectInteraction with: anotherObject) for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:53'!
onNewForClass: aClass do: aBlock

	| localCallback |
	
	localCallback := (Compiler evaluate: aBlock asString).

	Interpreter on: MessageReceived for: aClass do: [:reifications :reflectogram | 
		
		reifications message selector = #new ifTrue: [
			localCallback value: reifications value: reflectogram.
		].
				
	]. ! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:54'!
onReadFor: anObject do: aBlock


	Interpreter on: IvRead for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:54'!
onReadForClass: aClass do: aBlock

	aClass allInstances do: [:inst |
		self onReadFor: inst do: aBlock 
	].! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 16:49'!
onReceiveFor: anObject do: aBlock

	"local callback"

	Interpreter on: MessageReceived for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:55'!
onSendFor: anObject do: aBlock

	Interpreter on: MessageSent for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:55'!
onStoreFor: anObject do: aBlock

	Interpreter on: Stored for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:56'!
onWriteFor: anObject do: aBlock

	Interpreter on: IvWrite for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:56'!
onWriteForClass: aClass do: aBlock

	aClass allInstances do: [:inst |
		self onReadFor: inst do: aBlock 
	].! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:37'!
overForProcess: aProcess 

	aProcess handler over

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:40'!
packageNamed: aPackageNameAsString 

	"this can be done through vm access in order to avoid local reflection dependency,
	after bootstraping the mirror hierarchy ideally this dependency is not needed"

	^ self packagesDictionary at: aPackageNameAsString ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 10:44'!
packageNames

	^ PackageOrganizer default packageNames! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 4/8/2013 15:34'!
packageOfClass: aClass

	^ PackageOrganizer default packageOfClass: aClass.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/13/2013 18:34'!
packages

	^ PackageOrganizer default packages ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:39'!
packagesDictionary

	^ PackageOrganizer default instVarNamed: #packages! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 8/2/2013 12:41'!
perform: aSelector withReceiver: baseObject andArguments: arguments
	
	|exception responce args|

	arguments xxx___isProxy ifTrue: [
		args := arguments asLocalObject "better as shallowCopy"		
	] ifFalse: [
		args := arguments
	].

	[[responce := baseObject perform: aSelector withArguments: args] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[(responce = nil) & (exception = nil)] whileTrue: [ Processor yield ]. "active waiting on computation"

	^ responce ifNil: [exception]! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:34'!
proceedForProcess: aProcess 

	aProcess handler proceed 

	! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:16'!
protocolOfMethod: aMethod

	^ aMethod protocol! !

!RunTimeDebuggingSupport class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:31'!
protocolsForClass: aClass 

	|protocols|
	
	protocols := Set new.

	aClass methodDict do: [:method | protocols add: method protocol].
	
	^ protocols asOrderedCollection.! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/29/2013 18:51'!
receiverForContext: aContext 

	^ aContext receiver! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/12/2013 16:00'!
recompileCurrentMethodTo: aText forProcess: aProcess

	^ aProcess handler
		recompileCurrentMethodTo:  aText 
	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/24/2013 16:37'!
registerExceptionListener: aRequestor

	DebuggingSeed pushNewExceptionsTo: aRequestor.! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:35'!
removeInstVarNamed: anIvName inClass: baseObject

	baseObject removeInstVarNamed: anIvName ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 9/2/2013 16:22'!
removeMetaBehaviorForRegistered 

	Interpreter removeMetaBehaviorForRegistered ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:45'!
removeMethod: aString inClass: aClass

	aClass removeSelector: aString asSymbol 

! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:33'!
removePackageNamed: aPackageName

	^ PackageOrganizer default unregisterPackageNamed: aPackageName! !

!RunTimeDebuggingSupport class methodsFor: 'distribution' stamp: 'NickPapoulias 6/25/2013 15:13'!
resolveLocallyToDepth: n forObject:  anObject

	| objectGraph resolveRecursion |
	
	resolveRecursion := [:object :i | |objG|
		i = 0 
			ifTrue: [#() asDictionary] "leaf"
			ifFalse: [
				objG := Dictionary new. 
				object class instVarNames do: [:instName | |instance|
					instance := (object instVarNamed: instName).
					objG at: {instName . self vm_kernelClassOf: instance. instance asString} put: (resolveRecursion value: (object instVarNamed: instName) value: i-1)
				].
				objG.
			] 	
	].

	objectGraph := Dictionary new.
	objectGraph at: {'self' . self vm_kernelClassOf: anObject . anObject asString} put: (resolveRecursion value: anObject value: n).
	^ objectGraph.
	
! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:35'!
restartForProcess: aProcess 

	aProcess handler restart

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:15'!
run: aString

	[DebuggingSeed run: aString] fork. "will unload the RTSupport package"! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 8/20/2013 14:49'!
run: aSelector forTestClass: aTestClass

	^ (aTestClass run: aSelector) asString
! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:17'!
selectorOfMethod: aMethod

	^ aMethod selector! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:30'!
selectorsOfClass: aClass

	^ aClass methodDict keys! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/11/2013 12:15'!
setIvs: ivs forClass: aClass

	self vm_instVarOf: aClass at: 4 put: ivs. ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 4/11/2013 17:07'!
soleInstanceFor: metaClass

	^ metaClass soleInstance ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 4/11/2013 18:50'!
sourceForContext: aContext

	^ aContext debuggerMap sourceText! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:17'!
sourceOfMethod: aMethod

	^ aMethod sourceCode! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 15:05'!
sourceRangeForProcess: aProcess

	^ aProcess handler getCurrentPosition 

	! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 13:59'!
stackForProcess: aProcess

	^ aProcess handler stack 

	! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/11/2013 10:42'!
tempNamed: aTempName inContext: aContext 

	^ aContext tempNamed: aTempName! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/29/2013 18:54'!
tempNamesForContext: aContext 

	^ aContext tempNames! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 8/20/2013 16:13'!
testClassFor: aClass

	^ Smalltalk globals at: ((aClass name asString , 'Test')) asSymbol ifAbsent: [^ nil]
! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:35'!
throughForProcess: aProcess 

	aProcess handler through 

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:54'!
unhandledExceptions 

	^ DebuggingSeed unhandledExceptions ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_basicSizeOf: anObject

	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_changeClassTo: anotherClass of: anObject
	
	<primitive: 160 error: ec>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 16:43'!
vm_changeSuperClassOf: aClass To: aClassNameAsString

	self instVarOf: aClass at: 1 put: (Smalltalk globals at: aClassNameAsString) ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 12:45'!
vm_classNameOf: anObject

	(self vm_classOf: anObject) asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_classOf: anObject

	<primitive: 111>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'misc' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_environment

	^ Smalltalk globals ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_indexedOf: anObject at: index
	<primitive: 60>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:09'!
vm_indexedOf: anObject at: index put: anotherObject
	<primitive: 61>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instSizeOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ ((cformat bitShift: -10) bitAnd: 16rC0) + ((cformat bitShift: -1) bitAnd: 16r3F) - 1
	! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:31'!
vm_instVarIndexOf: anIvName forClass: aClass

	| index superC |
	superC := (self vm_instVarOf: aClass at: 1).
	index := (self ivsForClass: aClass) == nil 
		ifTrue: [0]
		ifFalse: [(self ivsForClass: aClass) indexOf: anIvName].
	index = 0 ifTrue: 
		[^superC == nil 
			ifTrue: [0]
			ifFalse: [self instVarIndexFor: anIvName forClass: superC]].
	^superC == nil 	
		ifTrue: [index]
		ifFalse: [index + superC instSize]! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 16:27'!
vm_instVarNamesOf: anObject

	^ self ivsForClass: (self vm_classOf: anObject) ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index
	<primitive: 73>
	self primitiveFailed

	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index put: anotherObject
	<primitive: 74>
	self primitiveFailed
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 15:09'!
vm_instVarOf: anObject named: anIvName

	"this can be done via primitives"

	^ self vm_instVarOf: anObject at: (self vm_instVarIndexOf: anIvName forClass:  (self vm_classOf: anObject))
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 15:12'!
vm_instVarOf: anObject named: anIvName put: aValue

	"this can be done via primitives"

	self vm_instVarOf: anObject 
		at: (self vm_instVarIndexOf: anIvName forClass:  (self vm_classOf: anObject)) 
		put: aValue
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:15'!
vm_kernelClassOf: anObject

	|classOfObject|

	classOfObject := self vm_classOf: anObject.
	
	[self kernelClasses includes: classOfObject asString] whileFalse: [
		classOfObject := self vm_instVarOf: classOfObject at: 1 "check the superclass"
	].

	^ classOfObject asString
		
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/9/2013 12:23'!
vm_objAsStringFor: baseObject

	^ baseObject asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_object: anObject equals: anotherObject

	<primitive: 110>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectFormatOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ cformat! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectTypeOf: anObject

	"see behavior type of class"
	
	|instSpec|
	
	instSpec := ((self vm_objectFormatOf: anObject) bitShift: -7) bitAnd: 16rF.
	instSpec = 12 ifTrue:[^#compiledMethod]. "Very special!!"
	instSpec >= 8 ifTrue:[^#bytes].
	((instSpec >= 8) not and:[(instSpec >= 6)]) ifTrue:[^#words].
	instSpec = 4 ifTrue:[^#weak].
	instSpec >= 2 ifTrue:[^#variable].
	^#normal.
	! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 19:03'!
whereForProcess: aProcess 

	^ aProcess handler where

	! !

Object subclass: #TestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-RunTimeDebuggingSupport'!

!TestClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/22/2013 16:57'!
run

	Point new.! !
